Level01_Shape = Core.class(Sprite)

function Level01_Shape:init(xworld)
	-- the ground
	local groundtexture = Texture.new("gfx/world/mytile32.png", true, {wrap = Texture.REPEAT})
	local levelmatrix = Matrix.new(1, 0, 0, 1, 0, 0)
	local levelcoords = {
		{x=-31,y=-3},
		{x=-31,y=4},
		{x=-20,y=4},
		{x=-14,y=0},
		{x=-9,y=0},
		{x=-9,y=-2},
		{x=-6,y=-2},
		{x=-4,y=0},
		{x=1,y=0},
		{x=6,y=4},
		{x=21,y=4},
		{x=21,y=-3},
		{x=23,y=-3},
		{x=23,y=4},
		{x=31,y=4},
		{x=31,y=-3},
		{x=33,y=-3},
		{x=33,y=8},
		{x=-33,y=5},
		{x=-33,y=-3},
		{x=-31,y=-3},
	}

	local levelscalex = 64 -- the scale of the level coors
	local levelscaley = 32 -- the scale of the level coors

	-- the shape
	local levelshape = Shape.new()
	levelshape:setFillStyle(Shape.TEXTURE, groundtexture, levelmatrix)
	levelshape:beginPath()
	levelshape:moveTo(levelcoords[1].x * levelscalex, levelcoords[1].y * levelscaley)
	for p = 2, #levelcoords do
		levelshape:lineTo(levelcoords[p].x * levelscalex, levelcoords[p].y * levelscaley)
	end
	levelshape:closePath()
	levelshape:endPath()
	levelshape:setPosition(levelshape:getWidth() / 2, levelshape:getHeight() / 2)

	-- the body
	self.levelbody = xworld:createBody {type = b2.STATIC_BODY}
	self.levelbody:setPosition(levelshape:getX(), levelshape:getY())
	local levelchain = b2.ChainShape.new()
	levelchain:createLoop(
		-31*levelscalex,-3*levelscaley,
		-31*levelscalex,4*levelscaley,
		-20*levelscalex,4*levelscaley,
		-14*levelscalex,0*levelscaley,
		-9*levelscalex,0*levelscaley,
		-9*levelscalex,-2*levelscaley,
		-6*levelscalex,-2*levelscaley,
		-4*levelscalex,0*levelscaley,
		1*levelscalex,0*levelscaley,
		6*levelscalex,4*levelscaley,
		21*levelscalex,4*levelscaley,
		21*levelscalex,-3*levelscaley,
		23*levelscalex,-3*levelscaley,
		23*levelscalex,4*levelscaley,
		31*levelscalex,4*levelscaley,
		31*levelscalex,-3*levelscaley,
		33*levelscalex,-3*levelscaley,
		33*levelscalex,8*levelscaley,
		-33*levelscalex,5*levelscaley,
		-33*levelscalex,-3*levelscaley,
		-31*levelscalex,-3*levelscaley
	)
	local levelfixture = self.levelbody:createFixture { shape = levelchain, density = 1, friction = 0.7, restitution = 0.01 }

	-- add to self
	self:addChild(levelshape)
end
