Collectibles = Core.class(Sprite)

function Collectibles:init(xworld, xtexture, xscalex, xscaley, xfixedrotation,
			xdensity, xrestitution, xfriction,
			xlvx, xlvy, xstartx, xstarty,
			xminposx, xminposy, xmaxposx, xmaxposy,
			xfixturetype)
	local mytexture = Texture.new(xtexture, true, {wrap = Texture.REPEAT})
	self.mybitmap = Bitmap.new(mytexture)
	self.mybitmap:setAnchorPoint(0.5, 0.5)
	self.mybitmap:setScale(xscalex, xscaley)
	self:addChild(self.mybitmap)

	self.body = xworld:createBody { type = b2.KINEMATIC_BODY }
	self.body:setPosition(xstartx, xstarty)
	self.body:setFixedRotation(xfixedrotation)
	self.shape = b2.PolygonShape.new()
	self.shape:setAsBox(self.mybitmap:getWidth() / 2, self.mybitmap:getHeight() / 2)
	self.fixture = self.body:createFixture {
		shape = self.shape, 
		density = xdensity, restitution = xrestitution, friction = xfriction,
		isSensor = true
	}
	self.fixture.type = xfixturetype or 0
	-- moving or not moving?
	self.lvx, self.lvy = xlvx, xlvy
	self.startx, self.starty = xstartx, xstarty
	self.minposx, self.minposy = xminposx, xminposy
	self.maxposx, self.maxposy = xmaxposx, xmaxposy
	self.distx, self.disty = xminposx or 0, xminposy or 0
	self.body:setLinearVelocity(xlvx or 0, xlvy or 0)

	-- listeners
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function Collectibles:onEnterFrame(dt)
	-- body
	-- bitmap
	self.mybitmap:setPosition(pfposx, pfposy)
end
