LF_Dynamic_Contour = Core.class(Sprite)

function LF_Dynamic_Contour:init(xworld, xtexture, xscalex, xscaley, xfixedrotation, xdensity, xrestitution, xfriction)
	local texture = Texture.new(xtexture)
	local image = Bitmap.new(texture)
	image:setScale(xscalex, xscaley)

	self.w, self.h = image:getWidth(), image:getHeight()
	local render = RenderTarget.new(self.w, self.h)
	render:draw(image)
	self.bitmap = Bitmap.new(render)
	self:addChild(self.bitmap)

	local contour = Contour.trace(render)
	contour = Contour.clean(contour)
	local shapes = Contour.shape(contour)

	self.body = xworld:createBody { type = b2.DYNAMIC_BODY }
	self.body:setFixedRotation(xfixedrotation)
	Contour.apply(self.body, shapes, { density = xdensity, restitution = xrestitution, friction = xfriction})

	-- listeners
	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
end

function LF_Dynamic_Contour:onEnterFrame(e)
	self.bitmap:setPosition(self.body:getPosition())
	self.bitmap:setRotation(self.body:getAngle() * 180 / math.pi)
end
